﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;

namespace HeuristicLab.Clients.Hive.WebJobManager.ViewModels
{
    /// <summary>
    /// Used for login
    /// </summary>
    public class LoginViewModel
    {
        /// <summary>
        /// Used only for the WebHive. Identifies logged in users.
        /// </summary>
        public Guid userId { get; set; }
        /// <summary>
        /// Login name from the user 
        /// </summary>
        [Display(Name = "Username")]
        public string loginName { get; set; }
        /// <summary>
        /// Encrypted password
        /// </summary>
        [Display(Name = "Password")]
        public string password { get; set; }

        public string errorMessage { get; set; }
        /// <summary>
        /// Initialize the loginViewModel. Creates a unique Guid for the WebHive 
        /// </summary>
        /// <param name="n">Login name</param>
        /// <param name="p">Encrypted password</param>
        public LoginViewModel(string n, string p)
        {
            loginName = n;
            password = p;
            userId = Guid.NewGuid();
        }
        public LoginViewModel()
        {
            userId = Guid.Empty;
            loginName = "";
            password = "";
        }
    }
}
