﻿using HeuristicLab.Clients.Access.Administration;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace HeuristicLab.Clients.Hive.WebJobManager.ViewModels.User
{
    public class UserViewModel
    {

        public string message { get; set; }
        public AccessAdministrationClient accessClient { get; set; }
        public List<Access.User> users { get; set; }
        public List<Access.Role> roles { get; set; }
        public List<Access.UserGroup> ugroups { get; set; }

        public Access.User SelectedUser { get; set; }
        public List<Access.UserGroup> SelectedUserSubscriptions { get; set; }
        public Access.UserGroup SelectedGroup { get; set; }
        public List<Access.UserGroupBase> SelectedGroupMembers { get; set; }

        public UserViewModel(AccessAdministrationClient ac)
        {
            users = new List<Access.User>();
            accessClient = ac;
            SelectedUser = new Access.User();
            SelectedGroup = new Access.UserGroup();
            SelectedUserSubscriptions = new List<Access.UserGroup>();
            SelectedGroupMembers = new List<Access.UserGroupBase>();
            
            
        }
        public UserViewModel refreshUsers()
        {
            accessClient.RefreshUsers();
            users = accessClient.Users.ToList();
            return this;
        }
        public UserViewModel refreshRoles()
        {
            accessClient.RefreshRoles();
            roles = accessClient.Roles.ToList();
            return this;
        }
        public UserViewModel refreshGroups()
        {
            accessClient.RefreshUserGroups();
            ugroups= accessClient.Groups.ToList();
            return this;
        }
        public Access.User getUserById(Guid id)
        {
            return users.Find(x => x.Id == id);
        }
        public Access.UserGroup getGroupById(Guid id)
        {
            return ugroups.Find(x => x.Id == id);
        }
    }
}
